[BACK]Return to update_openbsd CVS log [TXT][DIR] Up to [local] / openbsd / update_openbsd

Annotation of openbsd/update_openbsd/update_openbsd, Revision 1.70

1.1       andrew      1: #!/bin/sh
1.70    ! andrew      2: # $AFresh1: update_openbsd,v 1.69 2014/10/18 23:05:49 andrew Exp $
1.41      andrew      3: #
                      4: # Copyright (c) 2012 Andrew Fresh <andrew@afresh1.com>
                      5: #
                      6: # Permission to use, copy, modify, and distribute this software for any
                      7: # purpose with or without fee is hereby granted, provided that the above
                      8: # copyright notice and this permission notice appear in all copies.
                      9: #
                     10: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
                     11: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
                     12: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
                     13: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
                     14: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
                     15: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
                     16: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
                     17: #
1.7       andrew     18:
1.2       andrew     19: installed_sets() {
1.5       andrew     20:     local misc=/usr/share/doc/README
1.63      andrew     21:     local man=/usr/share/man/man1/intro.1
1.5       andrew     22:     local comp=/usr/bin/cc
                     23:     local game=/usr/games/
                     24:     local xbase=/usr/X11R6/
                     25:     local xetc=/etc/X11/xinit/xinitrc
                     26:     local xfont=/usr/X11R6/lib/X11/fonts
                     27:     local xserv=/usr/X11R6/bin/X
                     28:     local xshare=/usr/X11R6/bin/startx
                     29:
                     30:     local _c _d _e
                     31:     echo -n base
                     32:     echo -n ' etc'
1.3       andrew     33:     for _d in misc man comp game xbase xetc xfont xserv xshare; do
                     34:         eval _e=\$${_d}
                     35:         _c=`ls $_e 2> /dev/null | wc -l`
                     36:         #echo $_c $_d $_e
                     37:         if [ $_c -ne 0 ]; then
1.5       andrew     38:             echo -n " $_d"
1.2       andrew     39:         fi
                     40:     done
1.19      andrew     41:
1.34      andrew     42:     sendmail -d0.1 --badoption </dev/null 2>/dev/null | grep -q SASL
1.19      andrew     43:     if [ $? == 0 ]; then
                     44:         echo -n ' sendmail-smtp_auth'
                     45:     fi
1.2       andrew     46: }
1.7       andrew     47:
1.39      andrew     48: kernel_file_version() {
                     49:     echo exit | config -e $1 | grep -A1 ^OpenBSD
                     50:     #what $1 | sed -ne 's/[[:blank:]]\{1,\}//p'
                     51: }
                     52:
1.16      andrew     53: version_in() {
1.10      andrew     54:         local _proto=${FTP%%://*}
1.16      andrew     55:         local _file
1.10      andrew     56:
                     57:         if [ X"ftp" == X"${_proto}" ]; then
1.16      andrew     58:             local _list=`echo "ls base*.tgz" | ${FTP_CMD} ${FTP}/`
                     59:             _file=`echo ${_list} | awk '/base[0-9][0-9].tgz/ { print $9 }'`
1.15      andrew     60:
1.10      andrew     61:         elif [ X"http" == X"${_proto}" ]; then
1.16      andrew     62:             local _list=`${FTP_CMD} -V -o - ${FTP}/`
                     63:             _file=`echo ${_list} | awk '/[^x]base[0-9][0-9]*\.tgz/ {
1.15      andrew     64:                     sub("^.*base","base");
                     65:                     sub("\.tgz.*",".tgz");
                     66:                     print $0;
1.16      andrew     67:                 }'`
1.15      andrew     68:
                     69:         elif [ X"scp" == X"${_proto}" ]; then
                     70:             echo SCP is not yet supported >&2
                     71:             return 2
                     72:
1.10      andrew     73:         else
                     74:             echo Unsupported FTP ${FTP} >&2
1.12      andrew     75:             return 2
1.15      andrew     76:
1.10      andrew     77:         fi
1.16      andrew     78:
                     79:         local _v=${_file##*base}
                     80:         _v=${_v%.tgz*}
                     81:         echo $_v
1.10      andrew     82: }
1.2       andrew     83:
                     84: set_version() {
                     85:     CUR_VER=`uname -r`
1.3       andrew     86:     NEW_VER=`dc -e "$CUR_VER 0.1 + p"`
1.5       andrew     87:     FILE_VER=""
                     88:     FTP=""
1.2       andrew     89:
1.5       andrew     90:     local _cv=`echo $CUR_VER | sed -e 's/\.//'`
                     91:     local _nv=`echo $NEW_VER | sed -e 's/\.//'`
1.9       andrew     92:     local _v
1.5       andrew     93:
1.10      andrew     94:     if [ X"No" != X"$FORCE_DIR" -a -d $FORCE_DIR ]; then
1.5       andrew     95:         _dir=$FORCE_DIR
                     96:         if [ -e ${_dir}/base${_nv}.tgz ]; then
                     97:             _v=$_nv
                     98:         elif [ -e ${_dir}/base${_cv}.tgz ]; then
                     99:             NEW_VER=$CUR_VER
                    100:             _v=$_cv
                    101:         fi
1.2       andrew    102:
1.5       andrew    103:     elif [ -d $CUR_VER ]; then
                    104:         _dir=$CUR_VER
1.2       andrew    105:         NEW_VER=$CUR_VER
1.5       andrew    106:         if [ -e ${_dir}/base${_cv}.tgz ]; then
                    107:             _v=$_cv
                    108:         fi
1.2       andrew    109:
1.5       andrew    110:     elif [ -d $NEW_VER ]; then
                    111:         _dir=$NEW_VER
                    112:         if [ -e ${_dir}/base${_nv}.tgz ]; then
                    113:             _v=$_nv
                    114:         fi
1.2       andrew    115:
                    116:     fi
                    117:
1.17      andrew    118:     if [ X"" != X"${MIRROR}" -a X"" == X"${_v}" ]; then
1.10      andrew    119:         if [ X"No" == X"${FORCE_DIR}" ]; then
1.5       andrew    120:             _dir=${NEW_VER}
                    121:         else
                    122:             _dir=${FORCE_DIR}
                    123:         fi
                    124:         FTP=${MIRROR}/${_dir}/`machine`
1.2       andrew    125:
1.16      andrew    126:         _v=`version_in`
1.10      andrew    127:
1.16      andrew    128:         if [ X"" == X"${_v}" ]; then
1.10      andrew    129:             if [ X"No" != X"$FORCE_DIR" ]; then
                    130:                 echo No sets in forced [${FTP}] >&2
1.12      andrew    131:                 return 2
1.10      andrew    132:             fi
                    133:
                    134:             NEW_VER=$CUR_VER
                    135:             _dir=${NEW_VER}
                    136:             FTP=${MIRROR}/${_dir}/`machine`
                    137:
1.16      andrew    138:             _v=`version_in`
1.9       andrew    139:         fi
                    140:
1.10      andrew    141:         if [ X"" == X"${_v}" ]; then
1.16      andrew    142:             echo No sets in [${FTP}] >&2
1.12      andrew    143:             return 2
1.10      andrew    144:         elif [ X"${_cv}" == X"${_v}" ]; then
1.5       andrew    145:             NEW_VER=$CUR_VER
1.9       andrew    146:         elif [ X"${_nv}" == X"${_v}" ]; then
                    147:             NEW_VER=$NEW_VER
1.2       andrew    148:         else
1.10      andrew    149:             echo Invalid version [$_v] >&2
1.12      andrew    150:             return 2
1.2       andrew    151:         fi
                    152:
1.10      andrew    153:         if [ X"No" == X"$FORCE_DIR" ]; then
1.5       andrew    154:             _dir=$NEW_VER
1.2       andrew    155:         fi
                    156:
                    157:     fi
                    158:
1.5       andrew    159:     if [ X"" == X"${_v}" ]; then
1.64      andrew    160:         if [ X"" == X"${MIRROR}" ]; then
                    161:             echo ERROR: No sets, and no MIRROR, unable to continue. >&2
                    162:         else
                    163:             echo ERROR: Unable to determine FILE_VER, check your MIRROR. >&2
                    164:         fi
1.12      andrew    165:         return 1
1.2       andrew    166:     fi
                    167:
1.5       andrew    168:     if [ X"" == X"$RELEASEDIR" ]; then
                    169:         RELEASEDIR=`pwd`/$_dir
1.2       andrew    170:     fi
1.9       andrew    171:
1.5       andrew    172:     FILE_VER=$_v
1.17      andrew    173:     if [ X"" != X"${MIRROR}" ]; then
                    174:         FTP=${MIRROR}/${_dir}/`machine`
                    175:     fi
1.39      andrew    176:
                    177:     BOOT_KERNEL=`( \
                    178:         echo bsd; \
                    179:         [ -e /boot.conf ] && sed -E '/^ *(set +image|boot) +/!d ; \
                    180:             s///; s/^.*://; s/ .*$//' /boot.conf \
                    181:     ) | tail -1`
1.42      andrew    182:     BOOT_KERNEL=`follow_symlink /$BOOT_KERNEL`
1.39      andrew    183:     BOOT_KERNEL="/${BOOT_KERNEL#/}"
                    184:
                    185:     BOOT_KERNEL_VERSION=`kernel_file_version $BOOT_KERNEL`
                    186:
                    187:     BOOTED_KERNEL_VERSION=`sysctl -n kern.version`
                    188:     NEW_KERNEL_VERSION=""
                    189:
                    190:     # We want to default to what we had
                    191:     INSTALL_KERNELS="${BOOT_KERNEL#/}"
1.48      andrew    192:     # if the boot kernel was our specially named bsd.sp, we install from bsd
                    193:     if [ X"$INSTALL_KERNELS" == X"bsd.sp" ]; then
                    194:         INSTALL_KERNELS="bsd"
                    195:     fi
1.39      andrew    196:     # with a second option of an mp kernel if is is a likely candidate
                    197:     if [ X"$INSTALL_KERNELS" != X"bsd.mp" ]; then
                    198:         local _ncpu=$(sysctl -n hw.ncpufound)
                    199:         [ $_ncpu -gt 1 ] && INSTALL_KERNELS="$INSTALL_KERNELS bsd.mp"
                    200:     fi
                    201:     # or just bsd otherwise
                    202:     if [ X"${INSTALL_KERNELS% *}" != X"bsd" ]; then
                    203:         INSTALL_KERNELS="$INSTALL_KERNELS bsd"
                    204:     fi
                    205:     BOOT_KERNELS=$INSTALL_KERNELS
                    206:     INSTALL_KERNELS="$INSTALL_KERNELS bsd.rd"
1.2       andrew    207: }
                    208:
                    209: get_sets() {
1.54      andrew    210:     echo '==> GETTING SETS'
1.2       andrew    211:     if [ X"" == X"$FTP" ]; then
1.5       andrew    212:         echo ERROR: No FTP site set! >&2
1.12      andrew    213:         return 1
1.2       andrew    214:     fi
                    215:
1.5       andrew    216:     mkdir -p ${RELEASEDIR}
                    217:     cd $RELEASEDIR
1.2       andrew    218:
1.5       andrew    219:     local _v=$FILE_VER
1.2       andrew    220:
1.39      andrew    221:     for _b in $INSTALL_KERNELS; do
1.45      andrew    222:         if [ ! -e ./${_b} ]; then
1.54      andrew    223:             echo "===> $FTP_CMD ${FTP}/${_b}"
1.3       andrew    224:             $FTP_CMD ${FTP}/${_b}
1.70    ! andrew    225:         else
        !           226:             echo "===> Have ${_b}"
1.2       andrew    227:         fi
1.70    ! andrew    228:         kernel_file_version "${_b}"
1.2       andrew    229:     done
                    230:
1.5       andrew    231:     for _s in $INSTALLED_SETS; do
1.19      andrew    232:         local _file=${_s}${_v}.tgz
                    233:         if [ ${_s} == sendmail-smtp_auth ]; then
                    234:             _file=${_s}.gz
                    235:         fi
                    236:
                    237:         if [ ! -e ./${_file} ]; then
1.54      andrew    238:             echo "===> $FTP_CMD ${FTP}/${_file}"
1.19      andrew    239:             $FTP_CMD ${FTP}/${_file}
1.5       andrew    240:         fi
1.2       andrew    241:     done
                    242:
1.20      andrew    243:     local _type
1.56      andrew    244:     local _ftp
1.20      andrew    245:     for _type in $CHECKSUM_TYPES; do
1.40      andrew    246:         [ -e $_type ] && break
1.56      andrew    247:         _ftp=`echo "$FTP" | sed -e 's,://[^/]*/,://ftp.openbsd.org/,'`
                    248:         echo "===> $FTP_CMD ${_ftp}/$_type"
                    249:         $FTP_CMD ${_ftp}/$_type
1.20      andrew    250:     done
1.17      andrew    251: }
                    252:
1.23      andrew    253: follow_symlink () {
                    254:     local _file=$1
1.33      andrew    255:     # This could go circular, but I dunno how to fix that.
                    256:     if [ -h $_file ]; then
                    257:         follow_symlink $( file $_file |
                    258:             grep 'symbolic link' |
                    259:             sed -e s/^.*\\\`// -e s/\\\'\$// )
1.23      andrew    260:     else
1.33      andrew    261:         echo $_file
1.23      andrew    262:     fi
                    263: }
                    264:
1.20      andrew    265: check_sum () {
                    266:     local _type=$1
1.54      andrew    267:     echo "==> CHECKING $_type SUMS"
1.17      andrew    268:     cd $RELEASEDIR
                    269:
1.20      andrew    270:     if [ ! -e $_type ]; then
                    271:         echo $_type File does not exist!
1.17      andrew    272:         return 1
                    273:     fi
1.6       andrew    274:
1.57      andrew    275:     local _nv=`echo $NEW_VER | sed -e 's/\.//'`
1.61      andrew    276:     local _signify=`which signify 2>/dev/null`
1.67      andrew    277:     local _keyfile=/etc/signify/openbsd-${_nv}-base.pub
1.59      andrew    278:     local _b _s
1.57      andrew    279:
                    280:     (
1.58      andrew    281:         for _b in $INSTALL_KERNELS; do echo "($_b)"        ; done
                    282:         for _s in $INSTALLED_SETS;  do echo "($_s$_nv.tgz)"; done
1.57      andrew    283:     ) > index
1.59      andrew    284:
                    285:
                    286:     if [ -n "$_signify" -a "$_type" != "${_type%.sig}" ]; then
                    287:         echo "===> Checking signature";
                    288:         if [ ! -e $_keyfile ]; then
                    289:             echo "key [$_keyfile] does not exist, cannot check $_type" >&2
                    290:             return 2
                    291:         fi
1.67      andrew    292:         signify -V -e -p $_keyfile -x $_type -m - | grep -f index | sha256 -c -
1.59      andrew    293:     else
                    294:        grep -f index $_type | sum -c
                    295:     fi
1.2       andrew    296:
                    297:     if [ $? -ne 0 ]; then
1.20      andrew    298:         echo ERROR: $_type does not match! >&2
1.12      andrew    299:         return 1
1.2       andrew    300:     fi
                    301: }
                    302:
1.17      andrew    303: check_sets() {
1.54      andrew    304:     echo '==> CHECKING SETS'
1.17      andrew    305:     cd $RELEASEDIR
                    306:
1.18      andrew    307:     local _missing_sets
1.17      andrew    308:     local _v=$FILE_VER
                    309:
1.39      andrew    310:     for _n in $INSTALL_KERNELS; do
                    311:         local _o=$_n
                    312:         [ X"bsd" == X"${_o}" -a -e /bsd.sp ] && _o=bsd.sp
                    313:         if [ -e /${_o} -a ! -e ./${_n} ]; then
                    314:             echo ${_o} does not exist
                    315:             _missing_sets=1
1.17      andrew    316:         fi
1.39      andrew    317:
                    318:         if [ X"${BOOT_KERNEL}" == X"/${_o}" -a -e ./${_n} ]; then
                    319:             NEW_KERNEL_VERSION=`kernel_file_version ./${_n}`
1.17      andrew    320:         fi
                    321:     done
                    322:
1.39      andrew    323:     if [ X"$NEW_KERNEL_VERSION" == X"" ]; then
                    324:         echo Missing replacement for boot kernel $BOOT_KERNEL >&2
                    325:         _missing_sets=1
                    326:     fi
                    327:
1.17      andrew    328:     for _s in $INSTALLED_SETS; do
1.19      andrew    329:         local _file=${_s}${_v}.tgz
                    330:         if [ ${_s} == sendmail-smtp_auth ]; then
                    331:             _file=${_s}.gz
                    332:         fi
                    333:         if [ ! -e ./${_file} ]; then
                    334:             echo ${_file} does not exist
1.18      andrew    335:             _missing_sets=1
1.17      andrew    336:         fi
                    337:     done
1.18      andrew    338:
                    339:     if [ X"" == X"${_missing_sets}" ]; then
1.54      andrew    340:         echo '===> All OK'
1.18      andrew    341:     fi
1.17      andrew    342:
1.20      andrew    343:     local _type
                    344:     for _type in $CHECKSUM_TYPES; do
                    345:         if [ -e $_type ]; then
1.59      andrew    346:             check_sum $_type && break
1.62      andrew    347:             [ -z "$IGNORE_CHECKSUM_ERROR" ] && exit 1
1.20      andrew    348:         fi
                    349:     done
1.59      andrew    350:
                    351:     return 0
1.17      andrew    352: }
                    353:
                    354:
1.30      andrew    355: install_kernels() {
1.54      andrew    356:     echo '==> INSTALLING KERNEL'
1.2       andrew    357:
                    358:     if [ X"" == X"$RELEASEDIR" ]; then
1.5       andrew    359:         echo ERROR: no source for new kernels! >&2
1.2       andrew    360:         exit 1
                    361:     fi
                    362:
1.46      andrew    363:     if [ X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then
1.54      andrew    364:         echo "===> Backing up $BOOT_KERNEL to /obsd"
1.65      andrew    365:         ln -f $BOOT_KERNEL /obsd
1.46      andrew    366:         if [ $? -ne 0 ]; then
                    367:             echo "Error copying old kernel!" >&2
                    368:             exit 1
                    369:         fi
1.2       andrew    370:     fi
                    371:
1.39      andrew    372:     cd $RELEASEDIR
1.23      andrew    373:
1.39      andrew    374:     for _b in $INSTALL_KERNELS; do
1.65      andrew    375:         rm -f /nbsd
1.39      andrew    376:         local _bd=$_b
                    377:         [ X"${_b}" == X"bsd" ] && _bd="bsd.sp"
1.2       andrew    378:
1.39      andrew    379:         local _is_boot=""
                    380:         [ X"$BOOT_KERNEL" == X"/${_bd}" ] && _is_boot="# boot kernel"
                    381:
1.54      andrew    382:         echo "===> Copying $_b to /$_bd $_is_boot"
1.65      andrew    383:         cp ${_b} /nbsd && mv /nbsd /${_bd}
1.2       andrew    384:         if [ $? -ne 0 ]; then
1.39      andrew    385:             echo ERROR: Could not copy new $_bd kernel! >&2
1.2       andrew    386:             exit 1
                    387:         fi
1.39      andrew    388:     done
                    389:
                    390:     cd $OLDPWD
1.23      andrew    391:
1.39      andrew    392:     if [ ! -h /bsd ]; then
                    393:            cd /
                    394:         for _b in $BOOT_KERNELS; do
                    395:             [ X"$_b" == X"bsd" ] && _b="bsd.sp"
                    396:             if [ -e $_b ]; then
1.54      andrew    397:                 echo "===> symlinking $_b to /bsd"
1.65      andrew    398:                 ln -sf $_b bsd
1.39      andrew    399:                 if [ $? -ne 0 ]; then
                    400:                     echo ERROR: Could not symlink new kernel! >&2
                    401:                     exit 1
                    402:                 fi
                    403:                 break
                    404:             fi
                    405:         done
                    406:            cd $OLDPWD
1.2       andrew    407:     fi
                    408: }
                    409:
                    410: install_sets() {
1.54      andrew    411:     echo '==> INSTALLING SETS'
1.2       andrew    412:
                    413:     if [ X"" == X"$RELEASEDIR" ]; then
1.5       andrew    414:         echo ERROR: no source for sets! >&2
1.2       andrew    415:         exit 1
                    416:     else
                    417:         cd $RELEASEDIR
                    418:     fi
                    419:
1.5       andrew    420:     local _v=$FILE_VER
                    421:
1.21      andrew    422:     local _sets=`ls *${_v}.tgz | grep -v ^base `
                    423:     for _f in ${_sets} base${_v}.tgz; do
1.3       andrew    424:         _path=$DESTDIR
                    425:         if [ X"etc${_v}.tgz"  == X"$_f" \
                    426:             -o X"xetc${_v}.tgz" == X"$_f" ]; then
1.21      andrew    427:             [ X"" != X"$SYSMERGE" ] && continue
1.2       andrew    428:             _path=/var/tmp/temproot
                    429:         fi
                    430:
1.54      andrew    431:         echo "===> Extracting $_f to $_path"
1.65      andrew    432:         mkdir -p $_path
                    433:         tar -C $_path -xzphf ${RELEASEDIR}/${_f}
1.2       andrew    434:         if [ $? -ne 0 ]; then
1.5       andrew    435:             echo ERROR: Could not extract ${_f}! >&2
1.2       andrew    436:             exit 1
                    437:         fi
                    438:     done
                    439:
1.54      andrew    440:     echo '===> Extracted all sets.'
1.51      andrew    441: }
1.19      andrew    442:
1.51      andrew    443: install_sendmail_smtp_auth() {
1.19      andrew    444:     if [ -e ${RELEASEDIR}/sendmail-smtp_auth.gz ]; then
                    445:         gzcat ${RELEASEDIR}/sendmail-smtp_auth.gz > \
                    446:             ${RELEASEDIR}/sendmail-smtp_auth
                    447:     fi
                    448:     if [ -e ${RELEASEDIR}/sendmail-smtp_auth ]; then
1.21      andrew    449:         if ! pkg_info -qe 'cyrus-sasl-*'; then
1.65      andrew    450:             pkg_add -i cyrus-sasl
1.21      andrew    451:         fi
                    452:
1.65      andrew    453:         install -o root -g smmsp -m 2555 \
1.19      andrew    454:             ${RELEASEDIR}/sendmail-smtp_auth \
1.21      andrew    455:             /usr/libexec/sendmail/sendmail
1.19      andrew    456:
1.54      andrew    457:         echo '===> Installed sendmail with smtp_auth'
1.19      andrew    458:     fi
1.2       andrew    459: }
                    460:
                    461: update_etc() {
1.54      andrew    462:     echo '==> UPDATING ETC'
1.10      andrew    463:     if [ ! -e $SYSMERGE ]; then
1.47      andrew    464:         echo "ERROR: Can't find sysmerge!" >&2
                    465:         exit 1;
1.10      andrew    466:     fi
                    467:
1.68      andrew    468:     local _v=$FILE_VER
                    469:     local _args=""
                    470:
                    471:     if [ ! -e /usr/share/sysmerge/etc.tgz ]; then
                    472:         if [ X"" == X"$RELEASEDIR" ]; then
                    473:             echo "ERROR: no source for etc!" >&2
                    474:             exit 1
                    475:         fi
1.2       andrew    476:
1.68      andrew    477:         cd $RELEASEDIR
1.5       andrew    478:
1.68      andrew    479:         if [ -e etc${_v}.tgz ]; then
                    480:             _args="$_args -s ${RELEASEDIR}/etc${_v}.tgz"
                    481:         fi
                    482:         if [ -e xetc${_v}.tgz ]; then
                    483:             _args="$_args -x ${RELEASEDIR}/xetc${_v}.tgz"
                    484:         fi
                    485:         if [ X"" == X"$_args" ]; then
                    486:             echo ERROR: No upgrade sets found! >&2
                    487:             exit 1
                    488:         fi
1.47      andrew    489:     fi
1.68      andrew    490:
                    491:     echo '==> RUNNING SYSMERGE'
                    492:     $SYSMERGE $_args
1.2       andrew    493:
1.47      andrew    494:     cd $OLDPWD
1.2       andrew    495: }
1.14      andrew    496:
1.20      andrew    497:
1.65      andrew    498: if [ $(id -u) != 0 ]; then
                    499:     echo 'ERROR: need root privileges to run this script' >&2
                    500:     exit 1
                    501: fi
                    502:
1.14      andrew    503: if [ -e /etc/update_openbsd.conf ]; then
                    504:     . /etc/update_openbsd.conf
                    505: fi
                    506:
                    507: if [ -e ${HOME}/.update_openbsdrc ]; then
                    508:     . ${HOME}/.update_openbsdrc
                    509: fi
                    510:
1.17      andrew    511: #MIRROR=${MIRROR:=ftp://ftp.openbsd.org/pub/OpenBSD}
1.14      andrew    512: FTP_CMD=${FTP_CMD:=ftp -V}
                    513: PKG_PATH=${PKG_PATH:=/usr/ports/packages/`machine`/all/:${MIRROR}/`uname -r`/packages/`machine`/}
                    514:
                    515: DESTDIR=${DESTDIR:=/}
                    516: SYSMERGE=${SYSMERGE:=/usr/sbin/sysmerge}
                    517: FORCE_DIR=${FORCE_DIR:=No}
                    518:
                    519: INSTALLED_SETS=${INSTALLED_SETS:=`installed_sets`}
1.2       andrew    520:
1.59      andrew    521: CHECKSUM_TYPES=${CHECKSUM_TYPES:=SHA256.sig SHA256}
1.20      andrew    522:
1.2       andrew    523: set_version
1.12      andrew    524: local _error=$?
1.2       andrew    525:
                    526: echo
                    527: echo "-= update_openbsd - helper script to update OpenBSD =-"
                    528: echo "------------------------------------------------------"
                    529: echo
1.39      andrew    530: echo "       SYSMERGE: $SYSMERGE"
                    531: echo "         MIRROR: $MIRROR"
                    532: echo "     RELEASEDIR: $RELEASEDIR"
                    533: echo "        DESTDIR: $DESTDIR"
                    534: echo "    BOOT_KERNEL: $BOOT_KERNEL"
                    535: echo "INSTALL_KERNELS: $INSTALL_KERNELS"
                    536: echo " INSTALLED_SETS: $INSTALLED_SETS"
1.8       andrew    537: echo
1.39      andrew    538: echo "        CUR_VER: $CUR_VER"
                    539: echo "        NEW_VER: $NEW_VER"
                    540: #echo "       FILE_VER: $FILE_VER"
1.2       andrew    541: echo
1.70    ! andrew    542:
        !           543: for k in $INSTALL_KERNELS; do
        !           544:     if [ -e "/$k" ]; then
        !           545:         echo "Existing $k"
        !           546:         kernel_file_version "/$k"
        !           547:     fi
        !           548: done
1.12      andrew    549:
                    550: if [ ${_error} -ne 0 ]; then
                    551:        exit ${_error}
                    552: fi
1.2       andrew    553:
1.17      andrew    554: if [ X"" != X"${FTP}" ]; then
1.20      andrew    555:     get_sets
1.17      andrew    556: fi
                    557:
                    558: check_sets || exit
1.39      andrew    559:
1.54      andrew    560: echo "===> Last booted:\n$BOOTED_KERNEL_VERSION"
1.39      andrew    561: if [ X"$BOOT_KERNEL_VERSION" != X"$BOOTED_KERNEL_VERSION" \
                    562:   -a X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then
                    563:     echo "Next boot (unless replaced):\n$BOOT_KERNEL_VERSION"
                    564: fi
                    565: if [ -n "$NEW_KERNEL_VERSION" ]; then
1.54      andrew    566:     echo "===> New $BOOT_KERNEL:\n$NEW_KERNEL_VERSION";
1.39      andrew    567: else
                    568:     echo "\n!!! WARNING: Will not replace boot kernel $BOOT_KERNEL! !!!\n" >&2
                    569:     echo "ctrl+C to cancel, enter to continue anyway" >&2
1.44      andrew    570:     local _temp
                    571:     read _temp
1.53      andrew    572:     NEW_KERNEL_VERSION=$BOOT_KERNEL_VERSION
1.44      andrew    573: fi
                    574:
1.66      andrew    575: if [ X"$NEW_KERNEL_VERSION" != X"$BOOTED_KERNEL_VERSION" ]; then
1.44      andrew    576:     echo >&2
1.66      andrew    577:     echo "!!!  You are upgrading the OpenBSD kernel.        !!!" >&2
                    578:     echo "!!!  You will be given the opportunity to reboot  !!!" >&2
                    579:     echo "!!!  at the end of the proces but it is safer to  !!!" >&2
                    580:     echo "!!!  have a separate root shell open.             !!!" >&2
                    581:     echo "!!!  It is needed in order to run /sbin/oreboot.  !!!" >&2
                    582:     echo "!!!  sudo MAY NOT WORK after sets are extracted.  !!!" >&2
1.44      andrew    583:     echo >&2
1.66      andrew    584:     echo "enter to continue, ctrl+C to cancel" >&2
1.39      andrew    585:     local _temp
                    586:     read _temp
1.2       andrew    587:
1.66      andrew    588:     if [ ! -e /sbin/oreboot ]; then
                    589:         cp /sbin/reboot /sbin/oreboot
                    590:         if [ $? -ne 0 ]; then
                    591:             echo "Error copying old reboot command!" >&2
                    592:             exit 1
                    593:         fi
                    594:         echo "/sbin/reboot copied to /sbin/oreboot"
1.50      andrew    595:     fi
1.2       andrew    596: fi
                    597:
1.30      andrew    598: install_kernels
1.21      andrew    599: install_sets
1.2       andrew    600:
1.53      andrew    601: if [ X"$NEW_KERNEL_VERSION" == X"$BOOTED_KERNEL_VERSION" ]; then
1.51      andrew    602:     install_sendmail_smtp_auth
                    603:
1.21      andrew    604:     if [ -e /sbin/oreboot ]; then
                    605:         echo Removing /sbin/oreboot
1.69      andrew    606:         rm -f /sbin/oreboot
1.21      andrew    607:     fi
1.2       andrew    608:     update_etc
                    609:
1.54      andrew    610:     echo '==> UPDATING PACKAGES'
1.65      andrew    611:     pkg_add -ui -F update -F updatedepends
1.2       andrew    612:
                    613: else
                    614:     echo Instructions for updating to the new version available from
1.36      andrew    615:     if [ X"snapshots" == X"$FORCE_DIR" ]; then
1.30      andrew    616:         echo "  http://www.openbsd.org/faq/current.html"
                    617:     else
                    618:         echo "  http://www.openbsd.org/faq/upgrade${FILE_VER}.html"
                    619:     fi
1.2       andrew    620: fi
                    621:
1.66      andrew    622: echo Update complete. enter to reboot, ctrl+C to cancel
1.65      andrew    623: read _temp
1.22      andrew    624: if [ -e /sbin/oreboot ]; then
1.66      andrew    625:     echo using /sbin/oreboot
1.65      andrew    626:     /sbin/oreboot
                    627: else
                    628:     /sbin/reboot
1.22      andrew    629: fi

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>